Index: main/netsock2.c
===================================================================
--- main/netsock2.c	(revision 291421)
+++ main/netsock2.c	(working copy)
@@ -454,8 +454,19 @@
 int ast_set_qos(int sockfd, int tos, int cos, const char *desc)
 {
 	int res;
+	int addrform;
+	int proto_type = IPPROTO_IP;
+	int dscp_field = IP_TOS;
+	socklen_t len = sizeof(addrform);
 
-	if ((res = setsockopt(sockfd, IPPROTO_IP, IP_TOS, &tos, sizeof(tos)))) {
+	if (getsockopt(sockfd, IPPROTO_IPV6, IPV6_ADDRFORM, &addrform, &len) == -1) {
+		ast_log(LOG_WARNING, "getsockopt IPV6_ADDRFORM failed %s\n", strerror(errno));
+	} else if (addrform == PF_INET6) {
+		proto_type = IPPROTO_IPV6;
+		dscp_field = IPV6_TCLASS;
+	}
+
+	if ((res = setsockopt(sockfd, proto_type, dscp_field, &tos, sizeof(tos)))) {
 		ast_log(LOG_WARNING, "Unable to set %s TOS to %d (may be you have no "
 			"root privileges): %s\n", desc, tos, strerror(errno));
 	} else if (tos) {
